#!/usr/bin/env python

# Copyright 2008 David Selby dave6502@googlemail.com

# This file is part of kmotion.

# kmotion is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# kmotion is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with kmotion.  If not, see <http://www.gnu.org/licenses/>.

"""
Waits on the 'fifo_func' fifo until data received then check the
appropriate script exists and execute it
"""

import sys, os.path, time
import logger
 
log_level = 'WARNING'
logger = logger.Logger('kmotion_fund', log_level)


def main():  
    """
    Waits on the 'fifo_func' fifo until data received then check the
    appropriate script exists and execute it
    
    args    : 
    excepts : 
    return  : none
    """

    logger.log('starting daemon ...', 'CRIT')
    kmotion_dir = os.getcwd()[:-5]

    while True:
        pipein = open('%s/www/fifo_func' % kmotion_dir, 'r')
        data = pipein.readline().rstrip()
        
        if len(data) > 7 and data[-8:] == '99999999': # FIFO purge
            logger.log('FIFO purge', 'DEBUG')
            continue
        
        shell = '%s/func/func%02i.sh' % (kmotion_dir, int(data))
        if os.path.isfile(shell):
            logger.log('executing: %s' % shell, 'CRIT')
            os.popen3('nohup %s &' % shell)
        else:
            logger.log('can\'t find: %s' % shell, 'CRIT')
            
            
# it is CRUCIAL that this code is bombproof

while True:
    try:    
        main()
    except: # global exception catch
        logger.log('** CRITICAL ERROR ** kmotion_fund crash - type: %s' 
                   % sys.exc_info()[0], 'CRIT')
        logger.log('** CRITICAL ERROR ** kmotion_fund crash - value: %s' 
                   % sys.exc_info()[1], 'CRIT')
        logger.log('** CRITICAL ERROR ** kmotion_fund crash - traceback: %s' 
                   %sys.exc_info()[2], 'CRIT') 
        time.sleep(60)
           
    

